#
# spec file for package ghc-th-to-exp
#
# Copyright (c) 2017 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


%global pkg_name th-to-exp
%bcond_with tests
Name:           ghc-%{pkg_name}
Version:        0.0.1.1
Release:        4.1
Summary:        Provides a way to persist data from compile-time to runtime
License:        ISC
Group:          Development/Libraries/Haskell
URL:            https://hackage.haskell.org/package/%{pkg_name}
Source0:        https://hackage.haskell.org/package/%{pkg_name}-%{version}/%{pkg_name}-%{version}.tar.gz
BuildRequires:  ghc-Cabal-devel
BuildRequires:  ghc-rpm-macros
BuildRequires:  ghc-template-haskell-devel
%if %{with tests}
BuildRequires:  ghc-hspec-devel
%endif

%description
This package provides a way to persist data from compile-time to runtime by
producing Template Haskell expressions that evaluate to particular values.
For example, if you have a value 'Just 1', then 'toExp (Just 1)' will produce
the /expression/ '[e| Just 1 |]', which can be used in a splice. For a more
direct example, here’s what that looks like without the quasiquote notation:

>>> toExp (Just 1) AppE (ConE GHC.Base.Just) (LitE (IntegerL 1))

This is done by using a typeclass, 'ToExp', that can be automatically derived
for types that have a 'Generic' instance.

%package devel
Summary:        Haskell %{pkg_name} library development files
Group:          Development/Libraries/Haskell
Requires:       %{name} = %{version}-%{release}
Requires:       ghc-compiler = %{ghc_version}
Requires(post): ghc-compiler = %{ghc_version}
Requires(postun): ghc-compiler = %{ghc_version}

%description devel
This package provides the Haskell %{pkg_name} library development files.

%prep
%setup -q -n %{pkg_name}-%{version}

%build
%ghc_lib_build

%install
%ghc_lib_install

%check
%cabal_test

%post devel
%ghc_pkg_recache

%postun devel
%ghc_pkg_recache

%files -f %{name}.files
%doc LICENSE

%files devel -f %{name}-devel.files
%doc CHANGELOG.md README.md

%changelog
* Thu Aug 17 2017 psimons@suse.com
- Update to version 0.0.1.1.
* Thu Aug  3 2017 psimons@suse.com
- Updated with latest spec-cleaner version 0.9.8-8-geadfbbf.
* Tue Aug  1 2017 psimons@suse.com
- Update to version 0.0.1.0 revision 1.
* Tue Nov 22 2016 psimons@suse.com
- Update to version 0.0.1.0 with cabal2obs.
